/* NotificationStack.c generated by valac 0.46.13, the Vala compiler
 * generated from NotificationStack.vala, do not modify */

/*
 * Copyright 2020 elementary, Inc (https://elementary.io)
 *           2014 Tom Beckmann
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>
#include <meta/screen.h>
#include <gee.h>
#include <meta/meta-window-actor.h>
#include <stdlib.h>
#include <string.h>
#include <clutter/clutter.h>
#include <meta/window.h>
#include "gala.h"
#include <float.h>
#include <math.h>
#include <meta/boxes.h>
#include <meta/workspace.h>

#define GALA_TYPE_NOTIFICATION_STACK (gala_notification_stack_get_type ())
#define GALA_NOTIFICATION_STACK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_NOTIFICATION_STACK, GalaNotificationStack))
#define GALA_NOTIFICATION_STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_NOTIFICATION_STACK, GalaNotificationStackClass))
#define GALA_IS_NOTIFICATION_STACK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_NOTIFICATION_STACK))
#define GALA_IS_NOTIFICATION_STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_NOTIFICATION_STACK))
#define GALA_NOTIFICATION_STACK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_NOTIFICATION_STACK, GalaNotificationStackClass))

typedef struct _GalaNotificationStack GalaNotificationStack;
typedef struct _GalaNotificationStackClass GalaNotificationStackClass;
typedef struct _GalaNotificationStackPrivate GalaNotificationStackPrivate;
enum  {
	GALA_NOTIFICATION_STACK_0_PROPERTY,
	GALA_NOTIFICATION_STACK_SCREEN_PROPERTY,
	GALA_NOTIFICATION_STACK_NUM_PROPERTIES
};
static GParamSpec* gala_notification_stack_properties[GALA_NOTIFICATION_STACK_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block2Data Block2Data;

struct _GalaNotificationStack {
	GObject parent_instance;
	GalaNotificationStackPrivate * priv;
};

struct _GalaNotificationStackClass {
	GObjectClass parent_class;
};

struct _GalaNotificationStackPrivate {
	gint stack_x;
	gint stack_y;
	gint stack_width;
	MetaScreen* _screen;
	GeeArrayList* notifications;
};

struct _Block2Data {
	int _ref_count_;
	GalaNotificationStack* self;
	MetaWindowActor* notification;
};

static gint GalaNotificationStack_private_offset;
static gpointer gala_notification_stack_parent_class = NULL;

GType gala_notification_stack_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaNotificationStack, g_object_unref)
#define GALA_NOTIFICATION_STACK_TRANSITION_ENTRY_NAME "entry"
#define GALA_NOTIFICATION_STACK_TRANSITION_MOVE_STACK_ID "move-stack"
#define GALA_NOTIFICATION_STACK_TOP_OFFSET 2
#define GALA_NOTIFICATION_STACK_ADDITIONAL_MARGIN 12
#define GALA_NOTIFICATION_STACK_MARGIN 12
#define GALA_NOTIFICATION_STACK_WIDTH 300
GalaNotificationStack* gala_notification_stack_new (MetaScreen* screen);
GalaNotificationStack* gala_notification_stack_construct (GType object_type,
                                                          MetaScreen* screen);
void gala_notification_stack_show_notification (GalaNotificationStack* self,
                                                MetaWindowActor* notification);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void _vala_GValue_array_free (GValue * array,
                              gint array_length);
static void __lambda44_ (Block2Data* _data2_);
static void ___lambda44__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                       gpointer self);
static void gala_notification_stack_update_positions (GalaNotificationStack* self,
                                               gfloat add_y);
static void gala_notification_stack_move_window (MetaWindowActor* actor,
                                          gint x,
                                          gint y);
static void gala_notification_stack_update_stack_allocation (GalaNotificationStack* self);
MetaScreen* gala_notification_stack_get_screen (GalaNotificationStack* self);
void gala_notification_stack_destroy_notification (GalaNotificationStack* self,
                                                   MetaWindowActor* notification);
static void gala_notification_stack_set_screen (GalaNotificationStack* self,
                                         MetaScreen* value);
static GObject * gala_notification_stack_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void _gala_notification_stack_update_stack_allocation_meta_screen_monitors_changed (MetaScreen* _sender,
                                                                                    gpointer self);
static void _gala_notification_stack_update_stack_allocation_meta_screen_workareas_changed (MetaScreen* _sender,
                                                                                     gpointer self);
static void gala_notification_stack_finalize (GObject * obj);
static void _vala_gala_notification_stack_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_gala_notification_stack_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);

static inline gpointer
gala_notification_stack_get_instance_private (GalaNotificationStack* self)
{
	return G_STRUCT_MEMBER_P (self, GalaNotificationStack_private_offset);
}

GalaNotificationStack*
gala_notification_stack_construct (GType object_type,
                                   MetaScreen* screen)
{
	GalaNotificationStack * self = NULL;
	g_return_val_if_fail (screen != NULL, NULL);
	self = (GalaNotificationStack*) g_object_new (object_type, "screen", screen, NULL);
	return self;
}

GalaNotificationStack*
gala_notification_stack_new (MetaScreen* screen)
{
	return gala_notification_stack_construct (GALA_TYPE_NOTIFICATION_STACK, screen);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		GalaNotificationStack* self;
		self = _data2_->self;
		_g_object_unref0 (_data2_->notification);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}

static void
_vala_GValue_array_free (GValue * array,
                         gint array_length)
{
	if (array != NULL) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			g_value_unset (&array[i]);
		}
	}
	g_free (array);
}

static void
__lambda44_ (Block2Data* _data2_)
{
	GalaNotificationStack* self;
	self = _data2_->self;
	clutter_actor_remove_all_transitions ((ClutterActor*) _data2_->notification);
}

static void
___lambda44__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                  gpointer self)
{
	__lambda44_ (self);
}

void
gala_notification_stack_show_notification (GalaNotificationStack* self,
                                           MetaWindowActor* notification)
{
	Block2Data* _data2_;
	MetaWindowActor* _tmp0_;
	MetaWindow* window = NULL;
	MetaWindow* _tmp1_;
	gint scale = 0;
	ClutterPropertyTransition* opacity_transition = NULL;
	ClutterPropertyTransition* _tmp2_;
	GValue _tmp3_ = {0};
	GValue _tmp4_ = {0};
	ClutterKeyframeTransition* flip_transition = NULL;
	ClutterKeyframeTransition* _tmp5_;
	GValue _tmp6_ = {0};
	GValue _tmp7_ = {0};
	gdouble* _tmp8_;
	gdouble* _tmp9_;
	gint _tmp9__length1;
	GValue _tmp10_ = {0};
	GValue* _tmp11_;
	GValue* _tmp12_;
	gint _tmp12__length1;
	ClutterTransitionGroup* entry = NULL;
	ClutterTransitionGroup* _tmp13_;
	gfloat _tmp14_;
	gfloat _tmp15_;
	GeeArrayList* _tmp16_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (notification != NULL);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (notification);
	_g_object_unref0 (_data2_->notification);
	_data2_->notification = _tmp0_;
	clutter_actor_set_pivot_point ((ClutterActor*) _data2_->notification, 0.5f, 0.5f);
	_tmp1_ = meta_window_actor_get_meta_window (_data2_->notification);
	window = _tmp1_;
	meta_window_stick (window);
	scale = gala_utils_get_ui_scaling_factor ();
	_tmp2_ = (ClutterPropertyTransition*) clutter_property_transition_new ("opacity");
	opacity_transition = _tmp2_;
	g_value_init (&_tmp3_, G_TYPE_INT);
	g_value_set_int (&_tmp3_, 0);
	clutter_transition_set_from_value ((ClutterTransition*) opacity_transition, &_tmp3_);
	G_IS_VALUE (&_tmp3_) ? (g_value_unset (&_tmp3_), NULL) : NULL;
	g_value_init (&_tmp4_, G_TYPE_INT);
	g_value_set_int (&_tmp4_, 255);
	clutter_transition_set_to_value ((ClutterTransition*) opacity_transition, &_tmp4_);
	G_IS_VALUE (&_tmp4_) ? (g_value_unset (&_tmp4_), NULL) : NULL;
	_tmp5_ = (ClutterKeyframeTransition*) clutter_keyframe_transition_new ("rotation-angle-x");
	flip_transition = _tmp5_;
	g_value_init (&_tmp6_, G_TYPE_DOUBLE);
	g_value_set_double (&_tmp6_, 90.0);
	clutter_transition_set_from_value ((ClutterTransition*) flip_transition, &_tmp6_);
	G_IS_VALUE (&_tmp6_) ? (g_value_unset (&_tmp6_), NULL) : NULL;
	g_value_init (&_tmp7_, G_TYPE_DOUBLE);
	g_value_set_double (&_tmp7_, 0.0);
	clutter_transition_set_to_value ((ClutterTransition*) flip_transition, &_tmp7_);
	G_IS_VALUE (&_tmp7_) ? (g_value_unset (&_tmp7_), NULL) : NULL;
	_tmp8_ = g_new0 (gdouble, 1);
	_tmp8_[0] = 0.6;
	_tmp9_ = _tmp8_;
	_tmp9__length1 = 1;
	clutter_keyframe_transition_set_key_frames (flip_transition, (guint) 1, _tmp9_);
	_tmp9_ = (g_free (_tmp9_), NULL);
	g_value_init (&_tmp10_, G_TYPE_DOUBLE);
	g_value_set_double (&_tmp10_, -10.0);
	_tmp11_ = g_new0 (GValue, 1);
	_tmp11_[0] = _tmp10_;
	_tmp12_ = _tmp11_;
	_tmp12__length1 = 1;
	clutter_keyframe_transition_set_values (flip_transition, (guint) 1, _tmp12_);
	_tmp12_ = (_vala_GValue_array_free (_tmp12_, _tmp12__length1), NULL);
	_tmp13_ = (ClutterTransitionGroup*) clutter_transition_group_new ();
	entry = _tmp13_;
	clutter_timeline_set_duration ((ClutterTimeline*) entry, (guint) 400);
	clutter_transition_group_add_transition (entry, (ClutterTransition*) opacity_transition);
	clutter_transition_group_add_transition (entry, (ClutterTransition*) flip_transition);
	g_signal_connect_data ((ClutterActor*) _data2_->notification, "transitions-completed", (GCallback) ___lambda44__clutter_actor_transitions_completed, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	clutter_actor_add_transition ((ClutterActor*) _data2_->notification, GALA_NOTIFICATION_STACK_TRANSITION_ENTRY_NAME, (ClutterTransition*) entry);
	_tmp14_ = clutter_actor_get_height ((ClutterActor*) _data2_->notification);
	_tmp15_ = _tmp14_;
	gala_notification_stack_update_positions (self, _tmp15_);
	gala_notification_stack_move_window (_data2_->notification, self->priv->stack_x, (self->priv->stack_y + GALA_NOTIFICATION_STACK_TOP_OFFSET) + (GALA_NOTIFICATION_STACK_ADDITIONAL_MARGIN * scale));
	_tmp16_ = self->priv->notifications;
	gee_abstract_list_insert ((GeeAbstractList*) _tmp16_, 0, _data2_->notification);
	_g_object_unref0 (entry);
	_g_object_unref0 (flip_transition);
	_g_object_unref0 (opacity_transition);
	block2_data_unref (_data2_);
	_data2_ = NULL;
}

static void
gala_notification_stack_update_stack_allocation (GalaNotificationStack* self)
{
	gint primary = 0;
	MetaScreen* _tmp0_;
	MetaRectangle area = {0};
	MetaScreen* _tmp1_;
	MetaWorkspace* _tmp2_;
	MetaRectangle _tmp3_ = {0};
	gint scale = 0;
	MetaRectangle _tmp4_;
	MetaRectangle _tmp5_;
	MetaRectangle _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_screen;
	primary = meta_screen_get_primary_monitor (_tmp0_);
	_tmp1_ = self->priv->_screen;
	_tmp2_ = meta_screen_get_active_workspace (_tmp1_);
	meta_workspace_get_work_area_for_monitor (_tmp2_, primary, &_tmp3_);
	area = _tmp3_;
	scale = gala_utils_get_ui_scaling_factor ();
	self->priv->stack_width = (GALA_NOTIFICATION_STACK_WIDTH + GALA_NOTIFICATION_STACK_MARGIN) * scale;
	_tmp4_ = area;
	_tmp5_ = area;
	self->priv->stack_x = (_tmp4_.x + _tmp5_.width) - self->priv->stack_width;
	_tmp6_ = area;
	self->priv->stack_y = _tmp6_.y;
}

static void
gala_notification_stack_update_positions (GalaNotificationStack* self,
                                          gfloat add_y)
{
	gint scale = 0;
	gfloat y = 0.0F;
	gint i = 0;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_ = 0;
	gint delay_step = 0;
	g_return_if_fail (self != NULL);
	scale = gala_utils_get_ui_scaling_factor ();
	y = ((self->priv->stack_y + GALA_NOTIFICATION_STACK_TOP_OFFSET) + add_y) + (GALA_NOTIFICATION_STACK_ADDITIONAL_MARGIN * scale);
	_tmp0_ = self->priv->notifications;
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	i = _tmp2_;
	if (i > 0) {
		_tmp3_ = 150 / i;
	} else {
		_tmp3_ = 0;
	}
	delay_step = _tmp3_;
	{
		GeeArrayList* _actor_list = NULL;
		GeeArrayList* _tmp4_;
		GeeArrayList* _tmp5_;
		gint _actor_size = 0;
		GeeArrayList* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gint _actor_index = 0;
		_tmp4_ = self->priv->notifications;
		_tmp5_ = _g_object_ref0 (_tmp4_);
		_actor_list = _tmp5_;
		_tmp6_ = _actor_list;
		_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
		_tmp8_ = _tmp7_;
		_actor_size = _tmp8_;
		_actor_index = -1;
		while (TRUE) {
			MetaWindowActor* actor = NULL;
			GeeArrayList* _tmp9_;
			gpointer _tmp10_;
			MetaWindowActor* _tmp11_;
			MetaWindowActor* _tmp12_;
			MetaWindowActor* _tmp13_;
			MetaWindowActor* _tmp14_;
			MetaWindowActor* _tmp15_;
			gint _tmp16_;
			MetaWindowActor* _tmp17_;
			MetaWindowActor* _tmp18_;
			ClutterTransition* transition = NULL;
			MetaWindowActor* _tmp19_;
			ClutterTransition* _tmp20_;
			MetaWindowActor* _tmp21_;
			ClutterTransition* _tmp22_;
			ClutterTransition* _tmp23_;
			MetaWindowActor* _tmp24_;
			gfloat _tmp25_;
			gfloat _tmp26_;
			_actor_index = _actor_index + 1;
			if (!(_actor_index < _actor_size)) {
				break;
			}
			_tmp9_ = _actor_list;
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _actor_index);
			_tmp11_ = _g_object_ref0 ((MetaWindowActor*) _tmp10_);
			actor = _tmp11_;
			_tmp12_ = actor;
			clutter_actor_save_easing_state ((ClutterActor*) _tmp12_);
			_tmp13_ = actor;
			clutter_actor_set_easing_mode ((ClutterActor*) _tmp13_, CLUTTER_EASE_OUT_BACK);
			_tmp14_ = actor;
			clutter_actor_set_easing_duration ((ClutterActor*) _tmp14_, (guint) 200);
			_tmp15_ = actor;
			_tmp16_ = i;
			i = _tmp16_ - 1;
			clutter_actor_set_easing_delay ((ClutterActor*) _tmp15_, (guint) (_tmp16_ * delay_step));
			_tmp17_ = actor;
			gala_notification_stack_move_window (_tmp17_, -1, (gint) y);
			_tmp18_ = actor;
			clutter_actor_restore_easing_state ((ClutterActor*) _tmp18_);
			_tmp19_ = actor;
			_tmp20_ = clutter_actor_get_transition ((ClutterActor*) _tmp19_, "position");
			transition = _tmp20_;
			_tmp21_ = actor;
			_tmp22_ = transition;
			_tmp23_ = _g_object_ref0 (_tmp22_);
			g_object_set_data_full ((GObject*) _tmp21_, GALA_NOTIFICATION_STACK_TRANSITION_MOVE_STACK_ID, _tmp23_, g_object_unref);
			_tmp24_ = actor;
			_tmp25_ = clutter_actor_get_height ((ClutterActor*) _tmp24_);
			_tmp26_ = _tmp25_;
			y += _tmp26_;
			_g_object_unref0 (actor);
		}
		_g_object_unref0 (_actor_list);
	}
}

void
gala_notification_stack_destroy_notification (GalaNotificationStack* self,
                                              MetaWindowActor* notification)
{
	gfloat _tmp0_;
	gfloat _tmp1_;
	GeeArrayList* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (notification != NULL);
	clutter_actor_save_easing_state ((ClutterActor*) notification);
	clutter_actor_set_easing_duration ((ClutterActor*) notification, (guint) 100);
	clutter_actor_set_easing_mode ((ClutterActor*) notification, CLUTTER_EASE_IN_QUAD);
	clutter_actor_set_opacity ((ClutterActor*) notification, (guint) 0);
	_tmp0_ = clutter_actor_get_x ((ClutterActor*) notification);
	_tmp1_ = _tmp0_;
	clutter_actor_set_x ((ClutterActor*) notification, _tmp1_ + self->priv->stack_width);
	clutter_actor_restore_easing_state ((ClutterActor*) notification);
	_tmp2_ = self->priv->notifications;
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp2_, notification);
	gala_notification_stack_update_positions (self, 0.0f);
}

/**
     * This function takes care of properly updating both the actor
     * position and the actual window position.
     * 
     * To enable animations for a window we first need to move it's frame
     * in the compositor and then calculate & apply the coordinates for the window
     * actor.
     */
static void
gala_notification_stack_move_window (MetaWindowActor* actor,
                                     gint x,
                                     gint y)
{
	MetaWindow* window = NULL;
	MetaWindow* _tmp0_;
	MetaWindow* _tmp1_;
	MetaRectangle rect = {0};
	MetaWindow* _tmp2_;
	MetaRectangle _tmp3_ = {0};
	gint _tmp4_ = 0;
	gint _tmp6_ = 0;
	MetaWindow* _tmp8_;
	MetaWindow* _tmp9_;
	MetaRectangle _tmp10_ = {0};
	MetaRectangle _tmp11_;
	gfloat _tmp12_;
	gfloat _tmp13_;
	MetaRectangle _tmp14_;
	MetaRectangle _tmp15_;
	gfloat _tmp16_;
	gfloat _tmp17_;
	MetaRectangle _tmp18_;
	g_return_if_fail (actor != NULL);
	if (meta_window_actor_is_destroyed (actor)) {
		return;
	}
	_tmp0_ = meta_window_actor_get_meta_window (actor);
	window = _tmp0_;
	_tmp1_ = window;
	if (_tmp1_ == NULL) {
		return;
	}
	_tmp2_ = window;
	meta_window_get_frame_rect (_tmp2_, &_tmp3_);
	rect = _tmp3_;
	if (x != -1) {
		_tmp4_ = x;
	} else {
		MetaRectangle _tmp5_;
		_tmp5_ = rect;
		_tmp4_ = _tmp5_.x;
	}
	if (y != -1) {
		_tmp6_ = y;
	} else {
		MetaRectangle _tmp7_;
		_tmp7_ = rect;
		_tmp6_ = _tmp7_.y;
	}
	_tmp8_ = window;
	meta_window_move_frame (_tmp8_, FALSE, _tmp4_, _tmp6_);
	_tmp9_ = window;
	meta_window_get_buffer_rect (_tmp9_, &_tmp10_);
	rect = _tmp10_;
	_tmp11_ = rect;
	_tmp12_ = clutter_actor_get_width ((ClutterActor*) actor);
	_tmp13_ = _tmp12_;
	_tmp14_ = rect;
	_tmp15_ = rect;
	_tmp16_ = clutter_actor_get_height ((ClutterActor*) actor);
	_tmp17_ = _tmp16_;
	_tmp18_ = rect;
	clutter_actor_set_position ((ClutterActor*) actor, _tmp11_.x - ((_tmp13_ - _tmp14_.width) / 2), _tmp15_.y - ((_tmp17_ - _tmp18_.height) / 2));
}

MetaScreen*
gala_notification_stack_get_screen (GalaNotificationStack* self)
{
	MetaScreen* result;
	MetaScreen* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_screen;
	result = _tmp0_;
	return result;
}

static void
gala_notification_stack_set_screen (GalaNotificationStack* self,
                                    MetaScreen* value)
{
	g_return_if_fail (self != NULL);
	if (gala_notification_stack_get_screen (self) != value) {
		MetaScreen* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_screen);
		self->priv->_screen = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gala_notification_stack_properties[GALA_NOTIFICATION_STACK_SCREEN_PROPERTY]);
	}
}

static void
_gala_notification_stack_update_stack_allocation_meta_screen_monitors_changed (MetaScreen* _sender,
                                                                               gpointer self)
{
	gala_notification_stack_update_stack_allocation ((GalaNotificationStack*) self);
}

static void
_gala_notification_stack_update_stack_allocation_meta_screen_workareas_changed (MetaScreen* _sender,
                                                                                gpointer self)
{
	gala_notification_stack_update_stack_allocation ((GalaNotificationStack*) self);
}

static GObject *
gala_notification_stack_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaNotificationStack * self;
	GeeArrayList* _tmp0_;
	MetaScreen* _tmp1_;
	MetaScreen* _tmp2_;
	parent_class = G_OBJECT_CLASS (gala_notification_stack_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_NOTIFICATION_STACK, GalaNotificationStack);
	_tmp0_ = gee_array_list_new (meta_window_actor_get_type (), NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->notifications);
	self->priv->notifications = _tmp0_;
	_tmp1_ = self->priv->_screen;
	g_signal_connect_object (_tmp1_, "monitors-changed", (GCallback) _gala_notification_stack_update_stack_allocation_meta_screen_monitors_changed, self, 0);
	_tmp2_ = self->priv->_screen;
	g_signal_connect_object (_tmp2_, "workareas-changed", (GCallback) _gala_notification_stack_update_stack_allocation_meta_screen_workareas_changed, self, 0);
	gala_notification_stack_update_stack_allocation (self);
	return obj;
}

static void
gala_notification_stack_class_init (GalaNotificationStackClass * klass,
                                    gpointer klass_data)
{
	gala_notification_stack_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GalaNotificationStack_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_notification_stack_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_notification_stack_set_property;
	G_OBJECT_CLASS (klass)->constructor = gala_notification_stack_constructor;
	G_OBJECT_CLASS (klass)->finalize = gala_notification_stack_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_NOTIFICATION_STACK_SCREEN_PROPERTY, gala_notification_stack_properties[GALA_NOTIFICATION_STACK_SCREEN_PROPERTY] = g_param_spec_object ("screen", "screen", "screen", meta_screen_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}

static void
gala_notification_stack_instance_init (GalaNotificationStack * self,
                                       gpointer klass)
{
	self->priv = gala_notification_stack_get_instance_private (self);
}

static void
gala_notification_stack_finalize (GObject * obj)
{
	GalaNotificationStack * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_NOTIFICATION_STACK, GalaNotificationStack);
	_g_object_unref0 (self->priv->_screen);
	_g_object_unref0 (self->priv->notifications);
	G_OBJECT_CLASS (gala_notification_stack_parent_class)->finalize (obj);
}

GType
gala_notification_stack_get_type (void)
{
	static volatile gsize gala_notification_stack_type_id__volatile = 0;
	if (g_once_init_enter (&gala_notification_stack_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GalaNotificationStackClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_notification_stack_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaNotificationStack), 0, (GInstanceInitFunc) gala_notification_stack_instance_init, NULL };
		GType gala_notification_stack_type_id;
		gala_notification_stack_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaNotificationStack", &g_define_type_info, 0);
		GalaNotificationStack_private_offset = g_type_add_instance_private (gala_notification_stack_type_id, sizeof (GalaNotificationStackPrivate));
		g_once_init_leave (&gala_notification_stack_type_id__volatile, gala_notification_stack_type_id);
	}
	return gala_notification_stack_type_id__volatile;
}

static void
_vala_gala_notification_stack_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	GalaNotificationStack * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_NOTIFICATION_STACK, GalaNotificationStack);
	switch (property_id) {
		case GALA_NOTIFICATION_STACK_SCREEN_PROPERTY:
		g_value_set_object (value, gala_notification_stack_get_screen (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_gala_notification_stack_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	GalaNotificationStack * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_NOTIFICATION_STACK, GalaNotificationStack);
	switch (property_id) {
		case GALA_NOTIFICATION_STACK_SCREEN_PROPERTY:
		gala_notification_stack_set_screen (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

